#-*- coding:utf-8 -*-

"""
Name: Filebrowser_mod

This program is free software.This program is distributed 
WITHOUT ANY WARRANTY.You should use it on your own risk. 

You can modify/redistribute it under the terms of the 
GNU General Public License version 2 or later.
"""
__fbrws_script__ = "Filebrowser_mod"
__fbrws_ver__    = "0.02(2)"
__fbrws_author__ = 'masa'
__fbrws_web__    = "http://masaland.cocolog-nifty.com/"
#__Copyright__ = 'Copyright (c) 2009 masa'
__fbrws_Copyr__ = '(C) 2009 masa'

#------- config data---------------------------
Fbrws_ini_file = "E:\\Data\\masa\\Filebrowser.ini"
Fb_extension_list = "py,ini,log,lst,txt,cfg,dat,htm"
#you can add new app into Fb_open_app list
Fb_open_app = ["E:\\Python\\PyMyEditor.py",
            "C:\\Python\\py60tex.py"
           ] 
#----------------------------------------------

import sys
sys.setdefaultencoding('utf-8')
sys.path.insert(0, 'E:\\Python\\lib')

import os
import appuifw
import e32
import dir_iter
import re
import time
import types
from key_codes import EKeyLeftArrow
from key_codes import EKeyRightArrow

appuifw2_exist = 0
try:
    import appuifw2
    #appuifw = appuifw2
    appuifw2_exist = 1
except ImportError:
    #pass
    appuifw2_exist = 0


class Filebrowser:
    def __init__(self):
        self.lock = e32.Ao_lock()
        self.dir_stack = []
        self.current_dir = dir_iter.Directory_iter(e32.drive_list())
        self.entrylist = []
        self.copy_source = []
        self.entries = []
        self.cut_file = 0
        self.Open_app = ''
        self.Def_path = None
        self.MyEditor_exist = 0

    def run(self):
        global Fb_open_app
        for app_path in Fb_open_app:
            if os.path.exists(app_path):
                self.Open_app = app_path
                if os.path.basename(self.Open_app) == 'PyMyEditor.py':
                    sys.path.append(os.path.split(self.Open_app)[0])
                    import PyMyEditor
                    self.MyEditor_exist = 1
                    self.MyEdit = PyMyEditor.myeditor()
                break
        else:
            self.Open_app = ''
            appuifw.note(u'No correct open_app !\n Can not open by open_app.', 'info')

        self.check_inidata() #check Fbrws_ini_file and go to last_path or def_path
        self.list_setup()
        if appuifw2_exist == 1:
            self.lb = appuifw2.Listbox(self.entries, self.lbox_observe)
        else:
            self.lb = appuifw.Listbox(self.entries, self.lbox_observe)
        self.lb.bind(EKeyLeftArrow, lambda: self.lbox_observe(1))
        self.lb.bind(EKeyRightArrow, lambda: self.lbox_observe(2))
        old_title = appuifw.app.title
        self.refresh()
        self.lock.wait()
        appuifw.app.title = old_title
        appuifw.app.body = None
        self.lb = None
        self.write_inidata() #check Fbrws_ini_file and write last path string

    def refresh(self):
        appuifw.app.title = u"File browser"
        if self.current_dir.at_root:
            if self.Def_path:
                menu_list = [(u'Go to def dir' , lambda: self.lbox_observe(14)),
                             (u'Change open app' , self.change_open_app ),
                             (u'About' , self.about ),
                             (u'Exit', self.exit_key_handler)]
            else:
                menu_list = [(u'About' , self.about ),
                             (u'Change open app' , self.change_open_app ),
                             (u'Exit', self.exit_key_handler)]
        else:
            if self.copy_source and not self.cut_file: #Copy
                menu_list = [(u'File',
                               ((u'Open',    lambda: self.lbox_observe(4)),
                                (u'Rename',  lambda: self.lbox_observe(5)),
                                (u'New folder', lambda: self.lbox_observe(6)),
                                (u'Delete',  lambda: self.lbox_observe(7)),
                                (u'Property' , lambda: self.lbox_observe(13))
                              )),
                             (u'Edit',
                               ((u'Copy',         lambda: self.lbox_observe(8)),
                                (u'Paste',        lambda: self.lbox_observe(10)),
                                (u'Show clipbd',  lambda: self.lbox_observe(11)),
                                (u'Clear clipbd', lambda: self.lbox_observe(12))
                              ))]
            elif self.copy_source and self.cut_file: #Cut
                menu_list = [(u'File',
                               ((u'Open',    lambda: self.lbox_observe(4)),
                                (u'Rename',  lambda: self.lbox_observe(5)),
                                (u'New folder', lambda: self.lbox_observe(6)),
                                (u'Delete',  lambda: self.lbox_observe(7)),
                                (u'Property' , lambda: self.lbox_observe(13))
                              )),
                             (u'Edit',
                               ((u'Cut',          lambda: self.lbox_observe(9)),
                                (u'Paste',        lambda: self.lbox_observe(10)),
                                (u'Show clipbd',  lambda: self.lbox_observe(11)),
                                (u'Clear clipbd', lambda: self.lbox_observe(12))
                              ))]
            else: #No file in clipbd
                menu_list = [(u'File',
                               ((u'Open',    lambda: self.lbox_observe(4)),
                                (u'Rename',  lambda: self.lbox_observe(5)),
                                (u'New folder', lambda: self.lbox_observe(6)),
                                (u'Delete',  lambda: self.lbox_observe(7)),
                                (u'Property' , lambda: self.lbox_observe(13))
                              )),
                             (u'Edit',
                               ((u'Copy',         lambda: self.lbox_observe(8)),
                                (u'Cut',          lambda: self.lbox_observe(9))
                              ))]

            if self.Def_path:
                wk_etcmenu = [(u'Go to root dir' , lambda: self.lbox_observe(3)),
                              (u'Go to def  dir' , lambda: self.lbox_observe(14)),
                              (u'Change open app' , self.change_open_app ),
                              (u'About' , self.about ),
                              (u'Exit', self.exit_key_handler)]
            else:
                wk_etcmenu = [(u'Go to root dir' , lambda: self.lbox_observe(3)),
                              (u'Change open app' , self.change_open_app ),
                              (u'About' , self.about ),
                              (u'Exit', self.exit_key_handler)]
            menu_list = menu_list + wk_etcmenu
            if appuifw2_exist:
                wk_keymenu =(u'Left Arrow <---', lambda: self.lbox_observe(1))
                menu_list.insert(0,wk_keymenu)
        appuifw.app.menu = menu_list
        appuifw.app.exit_key_handler = self.exit_key_handler # self.do_dummy #
        appuifw.app.body = self.lb

    def list_setup(self):
        self.entries = self.current_dir.list_repr()
        if not self.current_dir.at_root:
            self.entries.insert(0, (u"..", u""))
            self.entries = [x[0] for x in self.entries]
        else:
            self.entries = [x[0] + "    " + x[1] for x in self.entries]
        self.entrylist = [x for x in self.entries]
        self.entries = self.sort_list(self.entries)


    def sort_list(self, list):
        wk_a = []
        wk_c = []
        for x in list:
            if x[0] == '[' or  x[0] == '.':
                wk_c.append(x)
            else:
                wk_a.append(x)
        return wk_c + wk_a


    def check_inidata(self):
        """check Fbrws_ini_file data and go to def_path"""
        if not os.path.exists(Fbrws_ini_file): return #
        FData = None
        try:
            F = open(Fbrws_ini_file,'r')
            try:
                FData = F.read()
            finally:
                F.close()
        except:
            pass
        if not FData: return

        #split by \n and omit line that contain only (CR/LF)
        lnDatalist = [x for x in FData.split("\n") if len(x) > 1]

        ini_path = None
        for lnData in lnDatalist:
            lnDatawk = re.sub("[ \t]+"," ",lnData)
            lnDatawk = (re.sub("[\n\r]+","",lnDatawk)).strip()
            confData = lnDatawk.split(" ")
            if   len(confData) < 2: continue # no confData[1] line
            elif confData[0]   == "def_path"  :
                ini_path = confData[1]
                self.Def_path = ini_path
            elif confData[0]   == "last_path" :
                if ini_path == None: ini_path = confData[1]
        if ini_path:
            self.go_default(ini_path)


    def write_inidata(self):
        """check Fbrws_ini_file and write last path string"""
        if not os.path.exists(Fbrws_ini_file): return #
        if self.Def_path:                return #

        FData = ''
        try:
            F = open(Fbrws_ini_file,'r')
            try:
                FData = F.read()
            finally:
                F.close()
        except:
            pass

        #split by \n and omit line that contain only (CR/LF)
        lnDatalist = [x for x in FData.split("\n") if len(x) > 1]

        conf_data = 'last_path ' + self.current_dir.name() + '\n'
        for lnData in lnDatalist:
            lnDatawk = (re.sub("[\n\r]+","",lnData)).strip()
            confData = lnDatawk.split(" ", 1)
            if len(confData) < 1: continue # no confData error
            if confData[0]   == "last_path":
                pass
            else:
                conf_data = conf_data + lnDatawk + '\n'
        try:
            F = open(Fbrws_ini_file, 'w')
            try:
                F.write(conf_data)
            finally:
                F.close()
        except:
            pass


    def search_id(self, dir):
        ent = self.current_dir.list_repr()
        #if not self.current_dir.at_root:     # don't inset "."  and "..",
        #    list.insert(0, (u".."))          # this is only memo *1
        ent = [x[0] for x in ent]
        entlist = [x for x in ent]
        ent = self.sort_list(ent)

        #change name's string into upper_case
        for n in range(len(ent)):
            ent[n] = ent[n].upper()
        for n in range(len(entlist)):
            entlist[n] = entlist[n].upper()
        dir = dir.upper()
        #
        try:
            disp_id = ent.index(dir)
            id = entlist.index(dir)
        except:
            disp_id = None
            id = None
        return disp_id, id

    def go_default(self, default_path=None):
        if not default_path: return
        def_path = os.path.normpath(default_path)
        if not type(def_path) == types.UnicodeType:
            def_path = unicode(def_path)  #given def_path is not in unicode

        self.dir_stack = []
        self.current_dir = dir_iter.Directory_iter(e32.drive_list())
        if not os.path.isdir(def_path):
            appuifw.note(u'No such def dir', 'info')
            return

        wk = def_path.split("\\")
        for x in wk:
            if x:  #when "." selected  ,splited last item is [] (enpty item)
                if self.current_dir.at_root:
                    disp_id, id = self.search_id(x) # C:/E:
                    if not id == None:
                        self.current_dir.add(id)
                        self.dir_stack.append(disp_id)
                    else:#  differ char upper/lower case 
                        #self.dir_stack = []
                        #self.current_dir = dir_iter.Directory_iter(e32.drive_list())
                        return
                else:
                    disp_id, id = self.search_id("["+ x +"]")
                    if not id == None:
                        self.current_dir.add(id)
                        self.dir_stack.append(disp_id + 1)  # +1 for ".." *1
                    else: # differ char upper/lower case
                        #self.dir_stack = []
                        #self.current_dir = dir_iter.Directory_iter(e32.drive_list())
                        return


    def change_open_app(self):
        global Fb_open_app
        name_list = []
        path_list = []
        if not self.Open_app: #Not exist correct open app path
            app_n = appuifw.popup_menu([u'--------'], u'No correct app path')
        else:
            for app_path in Fb_open_app:
                if os.path.exists(app_path):
                    name_list.append(u'- ' + unicode(os.path.basename(app_path)))
                    path_list.append(app_path)
            title_path = unicode(os.path.basename(self.Open_app))
            app_n = appuifw.popup_menu(name_list, u'Current: ' + title_path)
            if not app_n == None:
                self.Open_app = path_list[app_n]
                if os.path.basename(self.Open_app) == 'PyMyEditor.py':
                    if not self.MyEditor_exist: #not import yet
                        sys.path.append(os.path.split(self.Open_app)[0])
                        import PyMyEditor
                        self.MyEditor_exist = 1
                        self.MyEdit = PyMyEditor.myeditor()


    def syspath_conds(self):
        """delete duplicated E/C:\Python\lib"""
        flg_Elib = flg_Clib = 0
        wk = []
        for n in range(len(sys.path)):
            if (sys.path[n]).upper() == 'E:\\PYTHON\\LIB':
                if flg_Elib == 0:
                    wk.append(sys.path[n])
                    flg_Elib = 1
            elif (sys.path[n]).upper() == 'C:\\PYTHON\\LIB':
                if flg_Clib == 0:
                    wk.append(sys.path[n])
                    flg_Clib = 1
            else:
                wk.append(sys.path[n])
        sys.path = wk


    def do_exit(self):
        self.exit_key_handler()

    def do_dummy(self):
        return

    def exit_key_handler(self):
        appuifw.app.exit_key_handler = None
        self.lock.signal()

    def about(self):
        msg =     (__fbrws_script__) \
         + '\n' + ('Ver_' + __fbrws_ver__) \
         + '\n' + (__fbrws_Copyr__) \
         + '\n' + (__fbrws_web__ )
        appuifw.query(unicode(msg, "utf-8"), "query")

    def show_property(self):
        disp_Index = self.lb.current()
        Index = self.entrylist.index(self.entries[disp_Index])
        if Index == 0: # ".." selected
            Property = '.. selected'
        else:
            item = self.current_dir.entry(Index-1)
            if os.path.isdir(item):
                stime = time.localtime(os.path.getmtime(item) + 32400)
                ftime = time.strftime("%Y-%m-%d %H:%M:%S",stime)
                fsize = '----'
                Property = "["+ os.path.split(item)[1] +"]" + "\n" + ftime \
                                                     + "\n" + fsize + "b"
            elif os.path.isfile(item): # file
                stime = time.localtime(os.path.getmtime(item) + 32400)
                ftime = time.strftime("%Y-%m-%d %H:%M:%S",stime)
                fsize = str(os.path.getsize(item))
#                Property = os.path.basename(item) + "\n" + ftime + "\n" + fsize + "b"
                Property = self.entrylist[Index] + "\n" + ftime + "\n" + fsize + "b"
            else: # not file, would be a bug
                Property = 'Not file \n----b'
        rtn = appuifw.query(unicode(Property), "query")


    def __copy_file(self, item, disp_Index):
        item_file = os.path.basename(item)
        item_dir  = os.path.split(item)[0]
        if not self.copy_source: #First time copy (self.copy_source is empty)
            self.copy_source = [item]
            if not self.cut_file:
                appuifw.note(u'Added to clipbd\n'+ item_file, 'info')
            else:
                appuifw.note(u'Added to clipbd.It will delete after paste\n' + \
                                                             item_file, 'info')
            return disp_Index

        source_dir  = os.path.split(self.copy_source[0])[0]
        if not source_dir == item_dir: #not allowed different dir
            appuifw.note(u'Different dir! Can not copy.', 'error')
            return disp_Index

        check_flg = 0
        for x in self.copy_source:
            if item_file == os.path.basename(x):
                check_flg = 1
                break
        if check_flg: #same file
            appuifw.note(u'Already exist in Clipbd', 'info')
        else:
            self.copy_source.append(item)
            if not self.cut_file:
                appuifw.note(u'Added to clipbd\n'+ item_file, 'info')
            else:
                appuifw.note(u'Added to clipbd.It will delete after paste\n' + \
                                                           item_file, 'info')
        return disp_Index


    def __paste(self, item, disp_Index):
        last_file = ''
        paste_count = 0
        for source in self.copy_source:
          if not os.path.exists(source):
            #no such file, would be deleted or renamed after copy
            appuifw.note(u'No such file\nmay be deleted or renamed', 'info')
            continue #go to next file
          file = os.path.basename(source)
          copy_dest = os.path.join(item, file)
          new_name = unicode(file)

          OK = False
          while OK == False:
              if os.path.exists(copy_dest):
                  rtn = appuifw.query(u"File exists. Over write ?\n" + new_name, "query")
                  if rtn:  #Over write
                      OK = True  #break
                  else:  #Ask new_name
                      new_name = appuifw.query(u"File exists. Give a new name!" ,\
                             "text", new_name)
                      if new_name == None: #Paste canceled
                          OK = True  #break
                      else:
                          copy_dest = os.path.join(item, new_name)
              else: OK = True
          if new_name == None:
              continue #go to next file
          try:
              e32.file_copy(copy_dest, source)
              if self.cut_file: #selected file menu is 'Cut'
                  os.remove(source)
              last_file = new_name
              paste_count = paste_count + 1
          except:
              import sys
              type, value = sys.exc_info() [:2]
              appuifw.note(unicode(str(type)+'\n'+str(value)), 'error')

        if self.cut_file: #selected file menu is 'Cut'
            self.copy_source = []
            self.cut_file = 0

        if last_file: #copied file exist
            """move pointer to last pasted file"""
            self.list_setup()
            new_disp_Index = self.entries.index(unicode(last_file))

            appuifw.note(u'Pasted from clipbd\n  '+str(paste_count) +'file(s)', 'info')
            return new_disp_Index
        else:
            appuifw.note(u'No file pasted', 'info')
            return disp_Index


    def __make_dir(self, item, disp_Index):
        new_name = u"New_dir"
        OK = False
        while OK == False:
            new_name = appuifw.query(u'Directory name', 'text', new_name)
            if new_name == None: break
            dir_dest = os.path.join(item, new_name)
            if not os.path.exists(dir_dest):
                OK = True
        if new_name == None:
            return disp_Index
        try:
            os.mkdir(dir_dest)
            appuifw.note(u'New folder\n' + new_name, 'info')
        except:
            import sys
            type, value = sys.exc_info() [:2]
            appuifw.note(unicode(str(type)+'\n'+str(value)), 'error')

        #set new_name position to focused_item 
        self.list_setup()
        new_disp_Index = self.entries.index(u'[' + unicode(new_name) +']')
        return new_disp_Index


    def __rename(self, item, disp_Index): #Rename file / dir
        my_dir   = os.path.split(item)[0]
        new_name = unicode(os.path.split(item)[1])
        while True:
            new_name = appuifw.query(u'New name', 'text', new_name)
            if new_name:
                target = os.path.join(my_dir, new_name)
                if os.path.exists(target):
                    rtn = appuifw.query(u"Already exist\n" + new_name, "query")
                else:
                    break
            else:
                target = ''
                break
        if target == '':
            return disp_Index
        try:
            os.rename(item, target)
        except:
            import sys
            type, value = sys.exc_info() [:2]
            appuifw.note(unicode(str(type)+'\n'+str(value)), 'error')
        #set new_name position to focused_item 
        self.list_setup()
        if os.path.isdir(target): #dir
            new_disp_Index = self.entries.index(u'[' + unicode(new_name) + u']')
        else: #file
            new_disp_Index = self.entries.index(unicode(new_name))
        return new_disp_Index


    def __file_delete(self, item, disp_Index):
        if os.path.isdir(item): # dir
            appuifw.note(u'Not a regular file! Can not delete.', 'error')
        else:
            idx = appuifw.query(u"Delete ?\n" + os.path.basename(item), "query")
            if idx:
                try:
                    os.remove(item)
                except:
                    import sys
                    type, value = sys.exc_info() [:2]
                    appuifw.note(unicode(str(type)+'\n'+str(value)), 'error')
        return disp_Index


    def __get_file_menu(self, item):
        #variables for menu selection list
        m_open = u"Open"
        m_expy = u"Exec .py"
        m_copy = u"Copy"
        m_cut  = u"Cut"
        m_ren  = u"Rename"
        m_del  = u"Delete"

        f_extn = (os.path.splitext(item)[1][1:]).lower() #file ext'n without "."
        menu = None
        if f_extn == 'py':
            if self.copy_source and not self.cut_file:   #in Copy proccess
                m_list = [m_open, m_expy, m_copy, m_ren, m_del]
            elif self.copy_source and self.cut_file:     #in Cut process
                m_list = [m_open, m_expy, m_cut, m_ren, m_del]
            else:
                m_list = [m_open, m_expy, m_copy, m_cut, m_ren, m_del]
        else:
            if self.copy_source and not self.cut_file:   #in Copy proccess
                m_list = [m_open, m_copy, m_ren, m_del]
            elif self.copy_source and self.cut_file:     #n Cut process
                m_list = [m_open, m_cut, m_ren, m_del]
            else:
                m_list = [m_open, m_copy, m_cut, m_ren, m_del]

        i = appuifw.popup_menu(m_list)
        if not i == None:
            menu = m_list[i]
            m_alllist = [m_open, m_expy, m_copy, m_cut, m_ren, m_del]
            i = m_alllist.index(menu)
        return i


    def __open_file(self, item, disp_Index):
        global Fb_extension_list
        f_extn = (os.path.splitext(item)[1][1:]).lower() #file ext'n without "."
        if self.Open_app and re.search(f_extn,Fb_extension_list,2) != None:
            #change screen for waiting
            txt_body = appuifw.Text()
            appuifw.app.body = txt_body
            txt_body.set(u'  File open....')
            e32.ao_yield() #necessary for changing display
            #
            if os.path.basename(self.Open_app) == 'PyMyEditor.py' :
                self.MyEdit.run(item)
            else:
                import sys
                sys.argv.append(item)			#append file_name into argv
                execfile(self.Open_app,globals())	#open file by text_editor
                item_trush = sys.argv.pop()		#remove file_name from argv
                self.syspath_conds() #remove duplicated C/E:\Python\Lib
        else:
            try:
                appuifw.Content_handler().open(item)
                self.refresh()
            except:
                import sys
                type, value = sys.exc_info() [:2]
                appuifw.note(unicode(str(type)+'\n'+str(value)), "info")
        return disp_Index


    def lbox_observe(self, ind = None):
        if not ind == None:
            """ind 1: Left Arrow key
                   2: Right Arrow key
                   3: go to root menu
            """
            idx = ind
        else:
            idx = 0
        disp_Index = self.lb.current()
        Index = self.entrylist.index(self.entries[disp_Index])
        focused_item = 0

        if self.current_dir.at_root:
            if idx == 0 or idx == 2:                # Right Arrow key or select
                self.dir_stack.append(disp_Index)
                self.current_dir.add(Index)
            elif idx == 14:                              # Go to def dir
                self.go_default(self.Def_path)
            else:                                   # Left Arrow Key / etc
                focused_item = disp_Index           # don't move pointer

        elif idx == 0:                              # push selected
            if Index == 0:                          # ".." selected
                focused_item = self.dir_stack.pop()
                self.current_dir.pop()

            elif os.path.isdir(self.current_dir.entry(Index-1)):
                self.dir_stack.append(disp_Index)
                self.current_dir.add(Index-1)

            #here after, all item is file
            else:
                item = self.current_dir.entry(Index-1)
                i = self.__get_file_menu(item)

                if i == 0: # Open
                    focused_item = self.__open_file(item, disp_Index)

                elif i == 1: # Exec py
                    #check file ext'n without "."
                    f_extn = (os.path.splitext(item)[1][1:]).lower()
                    if f_extn == 'py':
                        execfile(item, globals())
                        e32.ao_yield() #necessary for change display
                        self.refresh()
                        self.syspath_conds() #remove duplicated C/E:\Python\Lib
                    focused_item = disp_Index

                elif i == 2: # copy
                    focused_item = disp_Index
                    if not os.path.isfile(item): # no need check, if yes would be a bug
                        appuifw.note(u'Not a regular file! Can not copy.', 'error')
                    else:
                        if self.copy_source and self.cut_file == 1:
                            appuifw.note(u'Already selected Cut! Please select again', 'error')
                        else:
                            self.cut_file = 0
                            focused_item = self.__copy_file(item, disp_Index)

                elif i == 3: # cut
                    focused_item = disp_Index
                    if not os.path.isfile(item): # no need check, if yes would be a bug
                        appuifw.note(u'Not a regular file! Can not copy.', 'error')
                    else:
                        if self.copy_source and self.cut_file == 0:
                            appuifw.note(u'Already selected Copy! Please select again', 'error')
                        else:
                            self.cut_file = 1
                            focused_item = self.__copy_file(item, disp_Index)

                elif i == 4: # rename
                    focused_item = self.__rename(item, disp_Index)

                elif i == 5: # Delete
                    focused_item = self.__file_delete(item, disp_Index)

                else:
                    focused_item = disp_Index

        elif idx == 1:                              # Left Arrow Key
            focused_item = self.dir_stack.pop()
            self.current_dir.pop()
        elif idx == 2:                              # Right Arrow Key
            if Index == 0 :                         # ".." selected
                focused_item = disp_Index
            elif os.path.isdir(self.current_dir.entry(Index-1)):
                self.dir_stack.append(disp_Index)
                self.current_dir.add(Index-1)
            else:                                   # file selected
                focused_item = disp_Index           # don't move pointer
        elif idx == 3:                              # go to root dir
            self.dir_stack = []
            self.current_dir = dir_iter.Directory_iter(e32.drive_list())

        elif idx == 6:                              # New folder
            dir_path = self.current_dir.name()
            focused_item = self.__make_dir(dir_path, disp_Index)

        elif idx == 10:                              # Paste
            dir_path = self.current_dir.name()
            focused_item = self.__paste(dir_path, disp_Index)

        elif idx == 11:                              # Show clipbd
            cb_file = []
            n = 0
            for x in self.copy_source:
                cb_file.append(unicode(os.path.basename(x)))
                n = n + 1
            if self.cut_file:
                msg = str(n) + ' file(s) in clipbd [Cut]'
            else:
                msg = str(n) + ' file(s) in clipbd [Copy]'
            rtn = appuifw.popup_menu(cb_file, unicode(msg))
            #focused_item = disp_Index
            return

        elif idx == 12:                              # Clear clipbd
            self.copy_source = []
            self.cut_file = 0
            appuifw.note(u'Clipbd cleared', 'info')

        elif idx == 13:                              # Property
            self.show_property()
            #focused_item = disp_Index
            return

        elif idx == 14:                              # Go to def dir
            self.go_default(self.Def_path)


        elif Index == 0 :                            # ".." selected
            focused_item = disp_Index

        elif idx == 4:                              # Open
            item = self.current_dir.entry(Index-1)
            if os.path.isdir(item): #dir
                self.dir_stack.append(disp_Index)
                self.current_dir.add(Index-1)
            else:   #file
                f_extn = (os.path.splitext(item)[1][1:]).lower() #file ext'n without "."
                if not f_extn == 'py': # not .py file
                    focused_item = self.__open_file(item, disp_Index)
                else: #.py file
                    i = appuifw.popup_menu([u"Open", u"Exec .py"])
                    if i == 0: # Open
                        focused_item = self.__open_file(item, disp_Index)
                    elif i == 1: # Exec py
                        execfile(item,globals())
                        e32.ao_yield() #necessary to change display
                        focused_item = disp_Index
                        self.refresh()
                        self.syspath_conds() #remove duplicated C/E:\Python\Lib
                    else: #cancel
                        focused_item = disp_Index

        elif idx == 5:                              # rename file / dir
            item = self.current_dir.entry(Index-1)
            focused_item = self.__rename(item, disp_Index)

        elif idx == 7:                              # Delete
            item = self.current_dir.entry(Index-1)
            """dir check is in __file_delete"""
            focused_item = self.__file_delete(item, disp_Index)

        elif idx == 8:                              # Copy
            focused_item = disp_Index
            item = self.current_dir.entry(Index-1)
            if not os.path.isfile(item): 
                appuifw.note(u'Not a regular file! Can not copy.', 'error')
            else:
                if self.copy_source and self.cut_file == 1:
                    appuifw.note(u'Already selected Cut! Please select again', 'error')
                else:
                    self.cut_file = 0
                    focused_item = self.__copy_file(item, disp_Index)

        elif idx == 9:                              # Cut
            focused_item = disp_Index
            item = self.current_dir.entry(Index-1)
            if not os.path.isfile(item):
                appuifw.note(u'Not a regular file! Can not copy.', 'error')
            else:
                if self.copy_source and self.cut_file == 0:
                    appuifw.note(u'Already selected Copy! Please select again', 'error')
                else:
                    self.cut_file = 1
                    focused_item = self.__copy_file(item, disp_Index)

        else:
            focused_item = disp_Index


        entries_bak = [x for x in self.entries] #*1 for appuifw2.Listbox
        self.list_setup()
        self.refresh()
        #*1 back to 0 Listbox pointer (need for appuifw2)
        if disp_Index >= len(self.entries):
            self.lb.set_list(entries_bak, 0) #*1
        self.lb.set_list(self.entries, focused_item)

if __name__ == '__main__':
    Filebrowser().run()
#appuifw.app.set_exit()
#sys.exit()
